config/routes.rb
Rails.application.routes.draw do
  devise_for :users
  #get 'movies/index'
  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html
  #get "/movies", to:"movies#index"
  root "movies#index"
  resources :movies do
 	 resources :reviews
 	end

 resources :moviegoers
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/movie.rb
class Movie < ApplicationRecord
	has_many :reviews, dependent: :destroy 

	def averageScore
		
		total = 0
		self.reviews.each do |r|
			total += r.score
		end
		
		return (total.to_f/self.reviews.count.to_f).round(2)
	end 

end

app/models/moviegoer.rb
class Moviegoer < ApplicationRecord
has_many :reviews, dependent: :destroy 

end

app/models/review.rb
class Review < ApplicationRecord
  belongs_to :movie
  belongs_to :moviegoer
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
	before_action :authenticate_user!

end

app/controllers/moviegoers_controller.rb
class MoviegoersController < ApplicationController

  def index
  	 @mvgs = Moviegoer.all
  end

  def show
    @mvg = Moviegoer.find(params[:id])
  end

  def new
  	@mvg = Moviegoer.new
  end

  def create
  	@mvg = Moviegoer.new(mvg_params)
  	if @mvg.save
      redirect_to @mvg
    else
      render :new
    end
  end

 def edit
    @mvg = Moviegoer.find(params[:id])
  end

def destroy
    @mvg = Moviegoer.find(params[:id])
    @mvg.destroy

    redirect_to root_path
  end

 def update
    @mvg = Moviegoer.find(params[:id])
    if @mvg.update(mvg_params)
      redirect_to @mvg
    else
      render :edit
    end
  end

	private
    def mvg_params
      params.require(:moviegoer).permit(:name, :bio)
    end


end

app/controllers/movies_controller.rb
class MoviesController < ApplicationController

  

  def index
  	 @movies = Movie.all
  end

  def show
    @movie = Movie.find(params[:id])
  end

  def new
  	@movie = Movie.new
  end

  def create
  	@movie = Movie.new(movie_params)
  	if @movie.save
      redirect_to @movie
    else
      render :new
    end
  end

 def edit
    @movie = Movie.find(params[:id])
  end

def destroy
    @movie = Movie.find(params[:id])
    @movie.destroy

    redirect_to root_path
  end

 def update
    @movie = Movie.find(params[:id])
    if @movie.update(movie_params)
      redirect_to @movie
    else
      render :edit
    end
  end

	private
    def movie_params
      params.require(:movie).permit(:title, :director, :year)
    end
end

app/controllers/reviews_controller.rb
class ReviewsController < ApplicationController

  def edit
    @review = Movie.find(params[:movie_id]).reviews.find(params[:id])
  end

  def update
    @review = Movie.find(params[:movie_id]).reviews.find(params[:id])
    
    if @review.update(review_params)
      redirect_to @review.movie
    else
      render :edit
    end
  end

  def create
    @movie = Movie.find(params[:movie_id])
    

    @review = @movie.reviews.create(review_params)
    redirect_to movie_path(@movie)
  end

  def destroy
    @movie = Movie.find(params[:movie_id])
    @review = @movie.reviews.find(params[:id])
    @review.destroy
    redirect_to movie_path(@movie)
  end

  private
    def review_params
      p = params.require(:review).permit(:body, :score, :moviegoer)
      {:body=> p[:body], :score=>p[:score], :moviegoer=>Moviegoer.find(p[:moviegoer])}
    end




end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/movies_helper.rb
module MoviesHelper
end

app/helpers/reviews_helper.rb
module ReviewsHelper
end

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Spoiled Potates</title>
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag 'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_pack_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
    <%= yield %>

<% if user_signed_in? %>
Logged in as <%= current_user.email%> [<%= link_to 'Logout', 
destroy_user_session_path, :method => :delete%>]
<% end %>

<% if not flash.empty? %> 
<hr>
<h3>Notifications:</h3>
<% flash.each do |type, msg| %>
  <div>
    <%= msg %>
  </div>
<% end %>
<% end %>
</body>
</html>

app/views/moviegoers/edit.html.erb
<h1>Edit Moviegoer Entry</h1>

<%= form_with model: @mvg do |form| %>
  <div>
    <%= form.label :name %><br>
    <%= form.text_field :name %>
  </div>

  <div>
    <%= form.label :bio %><br>
    <%= form.text_area :bio %>
  </div>

  <div>
    <%= form.submit %>
  </div>
<% end %>

app/views/moviegoers/index.html.erb
<style>
table, th, td {
  border: 1px solid black;
}
</style>

<h1>Moviegoers List</h1>

 <table style="width:100%">
  <tr>
    <th>Name</th>
    <th>Commands</th>
  </tr>

  <% @mvgs.each do |mvg| %>
  <tr>
    <td><%= mvg.name %></td>
    <td><table style="width:100%">  
		<td><%= link_to "Show Details", moviegoer_path(mvg.id)%></td>
    <td><%= link_to "Edit Profile", edit_moviegoer_path(mvg.id)%></td>
    <td><%= link_to "Destroy", moviegoer_path(mvg.id), method: :delete,
                  data: { confirm: "Are you sure?" } %></td>
  	</table>
	</td>
  </tr>
  <% end %> 
 
</table> 



<h2> Actions </h2>

<ul>
<li><%= link_to "Add A New Moviegoer", new_moviegoer_path %></li>
<li><%= link_to "Back Movie List", movies_path %></li>

</ul>




</ul>

app/views/moviegoers/new.html.erb
<h1>Add a New Moviegoer</h1>

<%= form_with model: @mvg do |form| %>
  <div>
    <%= form.label :name %><br>
    <%= form.text_field :name %>
  </div>
  <div>
    <%= form.label :bio %><br>
    <%= form.text_field :bio %>
  </div>

  <div>
    <%= form.submit %>
  </div>
<% end %>

app/views/moviegoers/show.html.erb
<style>
table, th, td {
  border: 1px solid black;
}
</style>


<h1> <%= @mvg.name %> </h1>

<hr>

<h2> Reviews </h2>

<% if @mvg.reviews.empty? %>
 <h3> No reviews yet! </h3>
<% end %>

<%@mvg.reviews.each do |review| %>
	<p>
		<bf>Body: </bf><%= review.body %> <br>
		<bf>Score: </bf><%= review.score %> <br>
	 <bf>Movie: </bf><%= review.movie.title %> <br>
  </p>

	<p>
  	<ul>
  	<li> <%= link_to "Edit Review", edit_movie_review_path(review.movie, review)  %></li>
  	<li><%= link_to 'Delete Review', [review.movie, review],
              method: :delete,
              data: { confirm: "Are you sure?" } %>
	</li>
	</ul>

<% end %>

<hr>
<h2> Reviewer Bio </h2>

 
<% if @mvg.bio.nil? or @mvg.bio.empty? %>
No Bio for this reviewer.... Shady...
<% else %>

<%= @mvg.bio %>
<% end %>
<hr>

<h2> Other Actions </h2>

<ul>
<li> <%= link_to "Edit Profile", edit_moviegoer_path(@mvg.id) %></li>
<li><%= link_to "Destroy", moviegoer_path(@mvg.id), method: :delete,
                  data: { confirm: "Are you sure?" } %></li>
<li>
	<%= link_to "Back Movie List", movies_path %>
</li>
</ul>

app/views/movies/edit.html.erb
<h1>Edit Movie Entry</h1>

<%= form_with model: @movie do |form| %>
  <div>
    <%= form.label :title %><br>
    <%= form.text_field :title %>
  </div>

  <div>
    <%= form.label :director %><br>
    <%= form.text_area :director %>
  </div>

  <div>
    <%= form.label :year %><br>
    <%= form.text_field :year %>
  </div>

  <div>
    <%= form.submit %>
  </div>
<% end %>

app/views/movies/index.html.erb
<style>
table, th, td {
  border: 1px solid black;
}
</style>

<h1>Movie List</h1>


 <table style="width:100%">
  <tr>
    <th>Title</th>
    <th>Director</th>
    <th>Year</th>
    <th>Number of Reviews</th>
    <th>Average Score</th>
    <th>Commands</th>
  </tr>

  <% @movies.each do |movie| %>
  <tr>
    <td><%= movie.title %></td>
    <td><%= movie.director %></td>
    <td><%= movie.year %></td>
    <td><%= movie.reviews.count %></td>
    <td><%= movie.averageScore %></td>
    <td><table style="width:100%">
    	<td><%= link_to "Edit", edit_movie_path(movie.id) %></td>
		<td><%= link_to "Destroy", movie_path(movie.id), method: :delete,
                  data: { confirm: "Are you sure?" } %></td>
    	<td><%= link_to "Reviews", movie_path(movie.id) %></td>
  		</table>
	</td>
  </tr>
  <% end %> 
 
</table> 

<hr>

<h2> Actions </h2>

<ul>

<li><%= link_to "Add A New Movie", new_movie_path %></li>
<li><%= link_to "List Moviegoers", moviegoers_path %></li>
<li><%= link_to "Add A New Moviegoer", new_moviegoer_path %></li>
</ul>

app/views/movies/new.html.erb
<h1>Add a New Movie</h1>

<%= form_with model: @movie do |form| %>
  <div>
    <%= form.label :title %><br>
    <%= form.text_field :title %>
  </div>

  <div>
    <%= form.label :director %><br>
    <%= form.text_area :director %>
  </div>

  <div>
    <%= form.label :year %><br>
    <%= form.text_field :year %>
  </div>

  <div>
    <%= form.submit %>
  </div>
<% end %>

app/views/movies/show.html.erb
<style>
table, th, td {
  border: 1px solid black;
}
</style>


<h1> <%= @movie.title %> </h1>

<h2> Movie Details </h2>

<p>Title: <%= @movie.title %></p>

<p>Director: <%= @movie.director %></p>

<p>Year: <%= @movie.year %></p>


<hr>

<h2> Reviews </h2>

<% if @movie.reviews.empty? %>
 <h3> No reviews yet! </h3>
<% end %>

<%@movie.reviews.each do |review| %>
	<p>
		<bf>Body: </bf><%= review.body %> <br>
		<bf>Score: </bf><%= review.score %> <br>
	 <bf>Author: </bf><%=link_to review.moviegoer.name, moviegoer_path(review.moviegoer) %> <br>
  </p>

	<p>
  	<ul>
  	<li> <%= link_to "Edit Review", edit_movie_review_path(review.movie, review)  %></li>
  	<li><%= link_to 'Delete Review', [review.movie, review],
              method: :delete,
              data: { confirm: "Are you sure?" } %>
	</li>
	</ul>

<% end %>

<hr>

<h2> Add a Review </h2>

<%= form_with model: [ @movie, @movie.reviews.build ] do |form| %>
  <p>
    <%= form.label :body %><br>
    <%= form.text_area :body %>
  </p>
  <p>
    <%= form.label :score %><br>
    <%= form.collection_select :score, [1,2,3,4,5,6,7,8,9,10], :to_i, :to_s%>
  </p>

  <p>
    <%= form.label :moviegoer %><br>
    <%= form.collection_select :moviegoer, Moviegoer.all, :id, :name%>
  </p>

  <p>
  	
    <%= form.submit "Save Review" %>
  </p>
<% end %>

<hr>

<h2> Other Actions </h2>

<ul>

<li><%= link_to "Edit", edit_movie_path(@movie.id) %></li>
<li><%= link_to "Destroy", movie_path(@movie.id), method: :delete,
                  data: { confirm: "Are you sure?" } %></li>
<li><%= link_to "Reviews", movie_path(@movie.id) %></li>

<li>
	<%= link_to "Back Movie List", movies_path %>
</li>
</ul>

app/views/reviews/edit.html.erb
<h2> Edit a Review </h2>

<%= form_with model: [ @review.movie, @review ] do |form| %>
  <p>
    <%= form.label :body %><br>
    <%= form.text_area :body %>
  </p>
  <p>
    <%= form.label :score %><br>
    <%= form.collection_select :score, [1,2,3,4,5,6,7,8,9,10], :to_i, :to_s%>
  </p>

  <p>
    <%= form.label :moviegoer %><br>
    <%= form.collection_select :moviegoer, Moviegoer.all, :id, :name%>
  </p>

  <p>
  	
    <%= form.submit "Save Review" %>
  </p>
<% end %>

app/views/users/shared/_error_messages.html.erb
<% if resource.errors.any? %>
  <div id="error_explanation">
    <h2>
      <%= I18n.t("errors.messages.not_saved",
                 count: resource.errors.count,
                 resource: resource.class.model_name.human.downcase)
       %>
    </h2>
    <ul>
      <% resource.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
    </ul>
  </div>
<% end %>

app/views/users/shared/_links.html.erb
<%- if controller_name != 'sessions' %>
  <%= link_to "Log in", new_session_path(resource_name) %><br />
<% end %>

<%- if devise_mapping.registerable? && controller_name != 'registrations' %>
  <%= link_to "Sign up", new_registration_path(resource_name) %><br />
<% end %>

<%- if devise_mapping.recoverable? && controller_name != 'passwords' && controller_name != 'registrations' %>
  <%= link_to "Forgot your password?", new_password_path(resource_name) %><br />
<% end %>

<%- if devise_mapping.confirmable? && controller_name != 'confirmations' %>
  <%= link_to "Didn't receive confirmation instructions?", new_confirmation_path(resource_name) %><br />
<% end %>

<%- if devise_mapping.lockable? && resource_class.unlock_strategy_enabled?(:email) && controller_name != 'unlocks' %>
  <%= link_to "Didn't receive unlock instructions?", new_unlock_path(resource_name) %><br />
<% end %>

<%- if devise_mapping.omniauthable? %>
  <%- resource_class.omniauth_providers.each do |provider| %>
    <%= link_to "Sign in with #{OmniAuth::Utils.camelize(provider)}", omniauth_authorize_path(resource_name, provider) %><br />
  <% end %>
<% end %>